﻿// XMLTransTool / XMLTransTool / TransData.cs
// CREATED AT 2023 / 12 / 25

namespace XMLTransTool;

/// <summary>
/// Obviously a primitive solution, improvements will be needed.
/// Todo: Directly Create Content From iterating FileSystem.
/// </summary>
public class TransData
{
    /// <summary>
    /// Todo: Implement Short FileName.
    /// </summary>
    public string FileName;
    public string FileNameFull;
    /// <summary>
    /// Key,Original,Target
    /// </summary>
    private Dictionary<string, KeyValuePair<string,string>> Content;


    public TransData(string fileNameFull)
    {
        FileNameFull = fileNameFull;
        FileName = "!!!Not Implemented Short Name!!!";
        Content = new();
    }
    public void AddText(string key,string eng, string target)
    {
        if (Content.ContainsKey(key))
        {
            throw new ArgumentException("Given Key has been defined Multiple times.",eng);
        }

        if (!Content.TryAdd(key,new KeyValuePair<string, string>(eng,target)))
            throw new ArgumentException("Failed to add given Key to internal Content Dict");
    }

    public void PrintContent()
    {
        Console.WriteLine("Now Printing Content of File [{0}]",FileNameFull);
        foreach (KeyValuePair<string,KeyValuePair<string,string>> pair in Content)
        {
            Console.WriteLine("{0} == {1}",pair.Key,pair.Value);
        }
    }

    public List<string> AllKeys()
    {
        return Content.Keys.ToList();
    }

    public List<string> AllSrcs()
    {
        List<string> r = new List<string>();
        foreach (KeyValuePair<string, KeyValuePair<string, string>> pair in Content)
        {
            r.Add(pair.Value.Key);
        }
        return r;
    }
    public List<string> AllTargets()
    {
        List<string> r = new List<string>();
        foreach (KeyValuePair<string, KeyValuePair<string, string>> pair in Content)
        { 
            r.Add(pair.Value.Value);
        }
        return r;
    }
}